aboutsummaryrefslogtreecommitdiffhomepage
diff options
context:
space:
mode:
-rw-r--r--.travis.yml127
-rwxr-xr-xscripts/if_changed.sh74
2 files changed, 150 insertions, 51 deletions
diff --git a/.travis.yml b/.travis.yml
index 691d9d5..178b318 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -1,3 +1,4 @@
+os: osx
osx_image: xcode9.2
language: objective-c
cache:
@@ -5,61 +6,85 @@ cache:
- cocoapods
rvm: 2.3.1
-before_install:
-# Add next line back with updated DeviceUDID for xcode9.1 if stability issues with simulator
-# - open -a "simulator" --args -CurrentDeviceUDID ABBD7191-486B-462F-80B4-AE08C5820DA1
- - bundle install
- - gem install xcpretty
- - bundle exec pod install --project-directory=Example --repo-update
- - bundle exec pod install --project-directory=Firestore/Example --no-repo-update
- - brew install clang-format
- - brew install swiftformat
- - brew install cmake
- - brew install go # Somehow the build for Abseil requires this.
- - echo "$TRAVIS_COMMIT_RANGE"
- - echo "$TRAVIS_PULL_REQUEST"
- - |
- if [ "$TRAVIS_PULL_REQUEST" == "false" ]; then
- SKIP_FIREBASE=0
- SKIP_FIRESTORE=0
- else
- git diff --name-only $TRAVIS_COMMIT_RANGE | grep -Eq '^(Firebase|Example)'
- SKIP_FIREBASE="$?"
- git diff --name-only $TRAVIS_COMMIT_RANGE | grep -q Firestore
- SKIP_FIRESTORE="$?"
- fi
-script:
- - ./scripts/check_whitespace.sh
- - ./scripts/check_copyright.sh
- - ./scripts/style.sh test-only $TRAVIS_COMMIT_RANGE
- - |
- # Google C++ style compliance
- if [ $SKIP_FIRESTORE != 1 ]; then
- ./scripts/lint.sh $TRAVIS_COMMIT_RANGE
- fi
+jobs:
+ include:
+ - stage: checks
+ # This only needs to be run once, so restrict it to an arbitrary combination
+ before_install:
+ - brew install clang-format
+ - brew install swiftformat
+ script:
+ - ./scripts/check_whitespace.sh
+ - ./scripts/check_copyright.sh
+ - ./scripts/style.sh test-only $TRAVIS_COMMIT_RANGE
+ # Google C++ style compliance
+ - ./scripts/lint.sh $TRAVIS_COMMIT_RANGE
- - |
- if [ $SKIP_FIREBASE != 1 ]; then
- ./test.sh
- fi
- - |
- if [ $SKIP_FIRESTORE != 1 ]; then
- ./Firestore/test.sh
- fi
+ - stage: test
+ env:
+ - PROJECT=Firebase PLATFORM=iOS
+ before_install:
+ # Add next line back with updated DeviceUDID for xcode9.1 if stability issues with simulator
+ # - open -a "simulator" --args -CurrentDeviceUDID ABBD7191-486B-462F-80B4-AE08C5820DA1
+ - bundle install
+ - gem install xcpretty
+ - ./scripts/if_changed.sh bundle exec pod install --project-directory=Example --repo-update
+ script:
+ - ./scripts/if_changed.sh ./scripts/build.sh $PROJECT $PLATFORM
-# TODO fix os_log deprecation warning in FIRLogger to remove --allow-warnings
- - |
- if [ $SKIP_FIREBASE != 1 ]; then
- bundle exec pod lib lint FirebaseCore.podspec --allow-warnings
- fi
+ # TODO fix os_log deprecation warning in FIRLogger to remove --allow-warnings
+ - ./scripts/if_changed.sh bundle exec pod lib lint FirebaseCore.podspec --allow-warnings
-# TODO - Uncomment subsequent lines once FirebaseCore source repo is in public Specs repo
-# - bundle exec pod lib lint FirebaseAuth.podspec
-# - bundle exec pod lib lint FirebaseDatabase.podspec
-# - bundle exec pod lib lint FirebaseMessaging.podspec --allow-warnings #pending #390 fix
-# - bundle exec pod lib lint FirebaseStorage.podspec
-# - bundle exec pod lib lint Firestore/Firestore.podspec
+ # TODO - Uncomment subsequent lines once FirebaseCore source repo is in public Specs repo
+ # - bundle exec pod lib lint FirebaseAuth.podspec
+ # - bundle exec pod lib lint FirebaseDatabase.podspec
+ # - bundle exec pod lib lint FirebaseMessaging.podspec
+ # - bundle exec pod lib lint FirebaseStorage.podspec
+ # - bundle exec pod lib lint FirebaseFirestore.podspec
+
+ - stage: test
+ env:
+ - PROJECT=Firestore PLATFORM=iOS METHOD=xcodebuild
+ before_install:
+ - bundle install
+ - gem install xcpretty
+ - ./scripts/if_changed.sh bundle exec pod install --project-directory=Firestore/Example --repo-update
+ script:
+ - ./scripts/if_changed.sh ./scripts/build.sh $PROJECT $PLATFORM $METHOD
+
+ - stage: test
+ env:
+ - PROJECT=Firestore PLATFORM=macOS METHOD=cmake
+ before_install:
+ - bundle install
+ - gem install xcpretty
+ - brew install cmake
+ - brew install go # Somehow the build for Abseil requires this.
+ - ./scripts/if_changed.sh bundle exec pod install --project-directory=Example --repo-update
+ - ./scripts/if_changed.sh bundle exec pod install --project-directory=Firestore/Example --no-repo-update
+ script:
+ - ./scripts/if_changed.sh ./scripts/build.sh $PROJECT $PLATFORM $METHOD
+
+ - stage: test
+ env:
+ - PROJECT=Firebase PLATFORM=macOS
+ before_install:
+ - bundle install
+ - gem install xcpretty
+ - ./scripts/if_changed.sh bundle exec pod install --project-directory=Example --repo-update
+ script:
+ - ./scripts/if_changed.sh ./scripts/build.sh $PROJECT $PLATFORM
+
+ - stage: test
+ env:
+ - PROJECT=Firebase PLATFORM=tvOS
+ before_install:
+ - bundle install
+ - gem install xcpretty
+ - ./scripts/if_changed.sh bundle exec pod install --project-directory=Example --repo-update
+ script:
+ - ./scripts/if_changed.sh ./scripts/build.sh $PROJECT $PLATFORM
branches:
only:
diff --git a/scripts/if_changed.sh b/scripts/if_changed.sh
new file mode 100755
index 0000000..616eebb
--- /dev/null
+++ b/scripts/if_changed.sh
@@ -0,0 +1,74 @@
+# Copyright 2018 Google
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# Within Travis, runs the given command if the current project has changes
+# worth building.
+#
+# Examines the following Travis-supplied environment variables:
+# - TRAVIS_PULL_REQUEST - the PR number or false for full build
+# - TRAVIS_COMMIT_RANGE - the range of commits under test; empty on a new
+# branch
+#
+# Also examines the following configured environment variables that should be
+# specified in an env: block
+# - PROJECT - Firebase or Firestore
+# - METHOD - xcodebuild or cmake
+
+function check_changes() {
+ if git diff --name-only "$TRAVIS_COMMIT_RANGE" | grep -Eq "$1"; then
+ run=true
+ fi
+}
+
+run=false
+
+# To force Travis to do a full run, change the "false" to "{PR number}" like
+# if [[ "$TRAVIS_PULL_REQUEST" == "904" ]]; then
+if [[ "$TRAVIS_PULL_REQUEST" == "false" ]]; then
+ # Full builds should run everything
+ run=true
+
+elif [[ -z "$TRAVIS_COMMIT_RANGE" ]]; then
+ # First builds on a branch should also run everything
+ run=true
+
+else
+ case "$PROJECT-$METHOD" in
+ Firebase-*)
+ check_changes '^(Firebase|Example)'
+ ;;
+
+ Firestore-xcodebuild)
+ check_changes '^Firestore/(core|third_party)'
+ ;;
+
+ Firestore-cmake)
+ check_changes '^Firestore'
+ ;;
+
+ *)
+ echo "Unknown project-method combo" 1>&2
+ echo " PROJECT=$PROJECT" 1>&2
+ echo " METHOD=$METHOD" 1>&2
+ exit 1
+ ;;
+ esac
+fi
+
+if [[ "$run" == true ]]; then
+ "$@"
+else
+ echo "skipped $*"
+fi
+